Before you start
----------------
Please make sure that you have docker(engine, cli) and imgpkg installed on the machine

https://docs.docker.com/desktop/
https://carvel.dev/imgpkg/docs/v0.24.0/install/

If the private registry is using self-signed certificates, please make sure that the VM on which you will be running the scripts trust the registry.

Content will be pulled from projects.registry.vmware.com. Suppose you need to host an airgapped registry at my.private.registry.com. The following directory structure needs to be used when using a private registry:
1. TKG images should end up in my.private.registry.com/tkg
2. Tanzu CLI plugin for the required TKG version should end up in my.private.registry.com/tanzu_cli/plugins/plugin-inventory:latest
2. CSE air-gapped images should end up in my.private.registry.com/vmware-cloud-director


Downloading and Uploading CSE air-gapped containers and dependencies to your private registry
---------------------------------------------------------------------------------------------
Pull the getting-started-airgapped image from projects.registry.vmware.com

docker pull projects.registry.vmware.com/vmware-cloud-director/getting-started-airgapped:v0.1.1

Expand the image to get access to the scripts

docker create --name "temp_container" projects.registry.vmware.com/vmware-cloud-director/getting-started-airgapped:v0.1.1
docker export "temp_container" -o temp_container.tar
docker container rm "temp_container"

mkdir -p temp_container_fs
tar -xvf temp_container.tar -C temp_container_fs
cd ./temp_container_fs/src/artifact

In this directory, run the following script
./getting_started "dependencies.txt" [Your registry]

Please feel free to edit the dependencies.txt file to customize what components you want to download. You can suppress processing of an air-gapped component by adding a # in front of the corresponding line in dependencies.txt. The default dependencies.txt packaged inside getting-started-airgapped image has the complete list of containers required to use CSE in an air-gapped fashion for TKG 1.6.1, 2.1.1, and 2.2.0.


Getting Tanzu Core packages
---------------------------
Tanzu core packages are hosted on projects.registry.vmware.com/tkg.
1. Using Tanzu CLI and documentation, host the TKG images at my.private.registry.com/tkg


Getting Tanzu CLI plugin
------------------------
Tanzu CLI plugin for TKG versions 1.6.1, 2.1.1, and 2.2.0 are hosted on projects.registry.vmware.com/tanzu_cli/plugins/plugin-inventory:latest
1. Using Tanzu CLI and documentation, host the Tanzu CLI plugin at my.private.registry.com/tanzu_cli/plugins/plugin-inventory:latest
